////////////////////////////////////////////////////////////////////////
// chat.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.chat")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("chat");

static const char* rawData = "\020\000\000\000\036\004\000\000\253\006\000\000\304\006\000\000<html>\n <head>\n  <title"
  ">ecpp-application chat</title>\n  <script src=\"ajax\" type=\"text/javascript\"></script>\n  <script type=\"text/java"
  "script\">\n\n   window.setInterval(\"updateChat()\", 1000);\n\n   var oldContent;\n\n   function onReceive(request)\n"
  "   {\n     var c = document.getElementById(\"chat\");\n     if (request.responseText != oldContent)\n     {\n       c"
  ".innerHTML = request.responseText;\n       oldContent = request.responseText;\n     }\n   }\n\n   function updateChat"
  "(ms)\n   {\n     ajaxGet(\"getchat\", onReceive);\n   }\n\n   function sendMessage()\n   {\n     var p = document.get"
  "ElementById(\"person\");\n     var m = document.getElementById(\"message\");\n     ajaxGet(\"putchat\?person=\" + esc"
  "ape(p.value) + \"&message=\" + escape(m.value),\n       onReceive);\n     m.value = \"\";\n     m.focus();\n   }\n\n "
  "  function addText(t)\n   {\n     var m = document.getElementById(\"message\");\n     m.value += t;\n   }\n\n  </scri"
  "pt>\n  <style type=\"text/css\">\n   .person {\n     font-weight: bold;\n   }\n   .message {\n     color: blue;\n   }"
  "\n  </style>\n </head>\n <body>\n  <h1></h1>\n\n  <form>\n   <table>\n    <tr>\n     <td>\n      your Name\n     </td"
  ">\n     <td>\n      <input type=\"text\" name=\"person\" id=\"person\" size=\"20\">\n     </td>\n    </tr>\n    <tr>"
  "\n     <td>\n      your Message\n     </td>\n     <td>\n      <input type=\"text\" name=\"message\" id=\"message\" si"
  "ze=\"80\"><br>\n     </td>\n    </tr>\n   </table>\n   <input type=\"button\" value=\"talk\" onClick=\"sendMessage()"
  "\">\n   <img src=\"smile\" onClick='addText(\" :) \")'>\n   <img src=\"sad\" onClick='addText(\" :( \")'>\n   <img sr"
  "c=\"wink\" onClick='addText(\" ;) \")'>\n  </form>\n  <script type=\"text/javascript\">\n   document.getElementById("
  "\"person\").focus();\n  </script>\n\n  <hr>\n  <div id=\"chat\"></div>\n\n </body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("chat " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
  // </%args>

  // <%cpp>
  reply.out() << data[0]; // <html>\n <head>\n  <title>ecpp-application chat</title>\n  <script src="ajax" type="text/javascript"></script>\n  <script type="text/javascript">\n\n   window.setInterval("updateChat()", 1000);\n\n   var oldContent;\n\n   function onReceive(request)\n   {\n     var c = document.getElementById("chat");\n     if (request.responseText != oldContent)\n     {\n       c.innerHTML = request.responseText;\n       oldContent = request.responseText;\n     }\n   }\n\n   function updateChat(ms)\n   {\n     ajaxGet("getchat", onReceive);\n   }\n\n   function sendMessage()\n   {\n     var p = document.getElementById("person");\n     var m = document.getElementById("message");\n     ajaxGet("putchat\?person=" + escape(p.value) + "&message=" + escape(m.value),\n       onReceive);\n     m.value = "";\n     m.focus();\n   }\n\n   function addText(t)\n   {\n     var m = document.getElementById("message");\n     m.value += t;\n   }\n\n  </script>\n  <style type="text/css">\n   .person {\n     font-weight: bold;\n   }\n   .message {\n     color: blue;\n   }\n  </style>\n </head>\n <body>\n  <h1>
#line 53 "chat.ecpp"
  reply.sout() << ( request.getArgs().size() > 0 ? request.getArgs()[0] : "Ajaxchat" );
  reply.out() << data[1]; // </h1>\n\n  <form>\n   <table>\n    <tr>\n     <td>\n      your Name\n     </td>\n     <td>\n      <input type="text" name="person" id="person" size="20">\n     </td>\n    </tr>\n    <tr>\n     <td>\n      your Message\n     </td>\n     <td>\n      <input type="text" name="message" id="message" size="80"><br>\n     </td>\n    </tr>\n   </table>\n   <input type="button" value="talk" onClick="sendMessage()">\n   <img src="smile" onClick='addText(" :) ")'>\n   <img src="sad" onClick='addText(" :( ")'>\n   <img src="wink" onClick='addText(" ;) ")'>\n  </form>\n  <script type="text/javascript">\n   document.getElementById("person").focus();\n  </script>\n\n  <hr>\n  <div id="chat">
  // <& getchat ...
  { 
#line 84 "chat.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 84 "chat.ecpp"
    callComp(tnt::Compident(std::string(), "getchat"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[2]; // </div>\n\n </body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
