////////////////////////////////////////////////////////////////////////
// getchat.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <tnt/comploader.h>
#include <tnt/tntconfig.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.getchat")

// <%pre>
#line 1 "global.ecpp"


#include <list>
#include <string>

struct chatMessage
{
  chatMessage() { }
  chatMessage(const std::string& person_, const std::string& message_)
    : person(person_),
      message(message_)
      { }

  std::string person;
  std::string message;
};

typedef std::list<chatMessage> chat_type;


#line 2 "getchat.ecpp"


#include <tnt/httpheader.h>


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    // <%config>
    static unsigned maxComments;
    // </%config>

};

class _component_Factory : public tnt::ComponentFactoryImpl<_component_>
{
  public:
    _component_Factory()
      : tnt::ComponentFactoryImpl<_component_>("getchat")
      { }
    tnt::Component* doCreate(const tnt::Compident& ci,
      const tnt::Urlmapper& um, tnt::Comploader& cl);
    virtual void doConfigure(const tnt::Tntconfig& config);
};

tnt::Component* _component_Factory::doCreate(const tnt::Compident& ci,
  const tnt::Urlmapper& um, tnt::Comploader& cl)
{
  return new _component_(ci, um, cl);
}

void _component_Factory::doConfigure(const tnt::Tntconfig& config)
{
  // <%config>
    if (config.hasValue("maxComments"))
      _component_::maxComments = tnt::stringTo<unsigned>("maxComments", "unsigned", config.getValue("maxComments"));
  // </%config>
}

static _component_Factory factory;

static const char* rawData = "\030\000\000\000 \000\000\000;\000\000\000W\000\000\000d\000\000\000m\000\000\000<table>"
  "\n <tr>\n  <td class=\"person\"></td>\n  <td class=\"message\"></td>\n </tr>\n</table>\n";

// <%shared>
// </%shared>

// <%config>
unsigned _component_::maxComments =  10;
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("getchat " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
  // </%args>

#line 28 "global.ecpp"
  typedef chat_type chat_type;
  TNT_APPLICATION_GLOBAL_VAR(chat_type, chat, "chat_type chat", ());   // <%application> chat_type chat
  // <%cpp>
  // <%include> global.ecpp
  // </%include>
#line 7 "getchat.ecpp"


  log_debug("getchat - " << chat.size() << " comments");

  reply.setHeader(tnt::httpheader::cacheControl, "no-cache");


  reply.out() << data[0]; // <table>\n
#line 15 "getchat.ecpp"
 for (chat_type::const_iterator it = chat.begin(); it != chat.end(); ++it) {

  reply.out() << data[1]; //  <tr>\n  <td class="person">
#line 17 "getchat.ecpp"
  reply.sout() << ( it->person );
  reply.out() << data[2]; // </td>\n  <td class="message">
#line 18 "getchat.ecpp"
  reply.out() << ( it->message );
  reply.out() << data[3]; // </td>\n </tr>\n
#line 20 "getchat.ecpp"
 }

  reply.out() << data[4]; // </table>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
