////////////////////////////////////////////////////////////////////////
// putchat.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <tnt/comploader.h>
#include <tnt/tntconfig.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.putchat")

// <%pre>
#line 1 "global.ecpp"


#include <list>
#include <string>

struct chatMessage
{
  chatMessage() { }
  chatMessage(const std::string& person_, const std::string& message_)
    : person(person_),
      message(message_)
      { }

  std::string person;
  std::string message;
};

typedef std::list<chatMessage> chat_type;


#line 6 "putchat.ecpp"


std::string replaceImg(std::string message, const std::string& txt,
  const std::string& repl)
{
  std::string::size_type n = 0;
  while ((n = message.find(txt, n)) != std::string::npos)
  {
    message.replace(n, txt.size(), repl);
    n += repl.size() - txt.size();
  }

  return message;
}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    // <%config>
    static unsigned maxComments;
    // </%config>

};

class _component_Factory : public tnt::ComponentFactoryImpl<_component_>
{
  public:
    _component_Factory()
      : tnt::ComponentFactoryImpl<_component_>("putchat")
      { }
    tnt::Component* doCreate(const tnt::Compident& ci,
      const tnt::Urlmapper& um, tnt::Comploader& cl);
    virtual void doConfigure(const tnt::Tntconfig& config);
};

tnt::Component* _component_Factory::doCreate(const tnt::Compident& ci,
  const tnt::Urlmapper& um, tnt::Comploader& cl)
{
  return new _component_(ci, um, cl);
}

void _component_Factory::doConfigure(const tnt::Tntconfig& config)
{
  // <%config>
    if (config.hasValue("maxComments"))
      _component_::maxComments = tnt::stringTo<unsigned>("maxComments", "unsigned", config.getValue("maxComments"));
  // </%config>
}

static _component_Factory factory;

static const char* rawData = "\010\000\000\000\t\000\000\000\n";

// <%shared>
// </%shared>

// <%config>
unsigned _component_::maxComments =  10;
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("putchat " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
std::string person = qparam.param("person");
std::string message = qparam.param("message");
  // </%args>

#line 28 "global.ecpp"
  typedef chat_type chat_type;
  TNT_APPLICATION_GLOBAL_VAR(chat_type, chat, "chat_type chat", ());   // <%application> chat_type chat
  // <%cpp>
  // <%include> global.ecpp
  // </%include>
#line 22 "putchat.ecpp"


  if (!message.empty())
  {
    log_info("new message from " << person << ": \"" << message << '"');

    message = replaceImg(message, ":)", "<img src=\"smile\">");
    message = replaceImg(message, ":(", "<img src=\"sad\">");
    message = replaceImg(message, ";)", "<img src=\"wink\">");

    chat.push_back(chatMessage(person, message));
    if (chat.size() > maxComments)
      chat.erase(chat.begin());
  }


  // <& getchat ...
  { 
#line 38 "putchat.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 38 "putchat.ecpp"
    callComp(tnt::Compident(std::string(), "getchat"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
